/*******************************************************************************
 *  Copyright CONSORTIUM COCKTAIL (www.cocktail.org), 1995, 2008
 *  
 *  This software is governed by the CeCILL license under French law and abiding
 *  by the rules of distribution of free software. You can use, modify and/or
 *  redistribute the software under the terms of the CeCILL license as circulated
 *  by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".
 *  
 *  As a counterpart to the access to the source code and rights to copy, modify
 *  and redistribute granted by the license, users are provided only with a
 *  limited warranty and the software's author, the holder of the economic
 *  rights, and the successive licensors have only limited liability.
 *  
 *  In this respect, the user's attention is drawn to the risks associated with
 *  loading, using, modifying and/or developing or reproducing the software by
 *  the user in light of its specific status of free software, that may mean that
 *  it is complicated to manipulate, and that also therefore means that it is
 *  reserved for developers and experienced professionals having in-depth
 *  computer knowledge. Users are therefore encouraged to load and test the
 *  software's suitability as regards their requirements in conditions enabling
 *  the security of their systems and/or data to be ensured and, more generally,
 *  to use and operate it in the same conditions as regards security.
 *  
 *  The fact that you are presently reading this means that you have had
 *  knowledge of the CeCILL license and that you accept its terms.
 * 
 *******************************************************************************/

package org.cocktail.kaki.client.gui;

import java.awt.BorderLayout;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;

import org.cocktail.application.client.eof.EOLolfNomenclatureDepense;
import org.cocktail.application.client.eof.EOOrgan;
import org.cocktail.application.client.swing.TableSorter;
import org.cocktail.application.client.swing.ZEOTable;
import org.cocktail.application.client.swing.ZEOTableCellRenderer;
import org.cocktail.application.client.swing.ZEOTableModel;
import org.cocktail.application.client.swing.ZEOTableModelColumn;
import org.cocktail.kaki.client.metier.EOCodeAnalytique;
import org.cocktail.kaki.client.metier.EOMois;
import org.cocktail.kaki.client.metier.EOPafAgent;
import org.cocktail.kaki.client.metier.EOPafAgentHisto;
import org.cocktail.kaki.client.metier.EOPafAgentLbud;
import org.cocktail.kaki.common.KakiConstantes;
import org.cocktail.kaki.common.KakiIcones;

import com.webobjects.eointerface.EODisplayGroup;
import com.webobjects.foundation.NSArray;

/**
 *
 * @author  cpinsard
 */
public class AgentHistoView extends javax.swing.JDialog {

    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	protected EODisplayGroup eod, eodMois, eodCumul, eodLbud;
	protected ZEOTable myEOTable, myEOTableMois, myEOTableCumul, myEOTableLbud;
	protected ZEOTableModel myTableModel, myTableModelMois, myTableModelCumul, myTableModelLbud;
	protected TableSorter myTableSorter, myTableSorterMois, myTableSorterCumul, myTableSorterLbud;

	ZEOTableCellRenderer myRenderer;

    /** Creates new form AffichageBSView */
    public AgentHistoView(java.awt.Frame parent, boolean modal, EODisplayGroup myEod, EODisplayGroup myEodMois, EODisplayGroup myEodCumul, EODisplayGroup myEodLbud, ZEOTableCellRenderer renderer) {

    	super(parent, modal);

        eod = myEod;
        eodMois = myEodMois;
        eodCumul = myEodCumul;
        eodLbud = myEodLbud;
        
        myRenderer = renderer;

        initComponents();
        
        initGui();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonClose = new javax.swing.JButton();
        tfTitre = new javax.swing.JTextField();
        viewTableMois = new javax.swing.JPanel();
        viewTableCout = new javax.swing.JPanel();
        viewTableBulletin = new javax.swing.JPanel();
        buttonPrintListe = new javax.swing.JButton();
        buttonPrintBS = new javax.swing.JButton();
        listeExercices = new javax.swing.JComboBox();
        viewTableLbud = new javax.swing.JPanel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        buttonClose.setText("Fermer");
        buttonClose.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonCloseActionPerformed(evt);
            }
        });

        tfTitre.setBackground(new java.awt.Color(51, 51, 51));
        tfTitre.setEditable(false);
        tfTitre.setFont(new java.awt.Font("Times New Roman", 0, 14));
        tfTitre.setForeground(new java.awt.Color(204, 204, 255));
        tfTitre.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        tfTitre.setText("PINSARD CYRIL - PAIE DE JANVIER 2010");
        tfTitre.setFocusable(false);
        tfTitre.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tfTitreActionPerformed(evt);
            }
        });

        viewTableMois.setLayout(new java.awt.BorderLayout());

        viewTableCout.setLayout(new java.awt.BorderLayout());

        viewTableBulletin.setLayout(new java.awt.BorderLayout());

        buttonPrintListe.setText("Liste");

        buttonPrintBS.setText("BS");

        listeExercices.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        viewTableLbud.setLayout(new java.awt.BorderLayout());

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(tfTitre, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 841, Short.MAX_VALUE)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(listeExercices, 0, 132, Short.MAX_VALUE)
                    .add(viewTableMois, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 132, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(viewTableBulletin, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 683, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, viewTableCout, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 683, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                        .add(buttonPrintBS, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 87, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(buttonPrintListe, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 91, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 380, Short.MAX_VALUE)
                        .add(buttonClose, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 119, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(org.jdesktop.layout.GroupLayout.LEADING, viewTableLbud, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 683, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(tfTitre, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(layout.createSequentialGroup()
                        .add(viewTableCout, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 52, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(viewTableBulletin, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 336, Short.MAX_VALUE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                        .add(viewTableLbud, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 91, Short.MAX_VALUE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(buttonClose)
                            .add(buttonPrintBS)
                            .add(buttonPrintListe)))
                    .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                        .add(listeExercices, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(viewTableMois, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 504, Short.MAX_VALUE)))
                .addContainerGap())
        );

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-857)/2, (screenSize.height-608)/2, 857, 608);
    }// </editor-fold>//GEN-END:initComponents

    
    
    
public javax.swing.JButton getButtonClose() {
		return buttonClose;
	}

	public void setButtonClose(javax.swing.JButton buttonClose) {
		this.buttonClose = buttonClose;
	}


public javax.swing.JButton getButtonPrintBS() {
		return buttonPrintBS;
	}

	public void setButtonPrintBS(javax.swing.JButton buttonPrintBS) {
		this.buttonPrintBS = buttonPrintBS;
	}

	public javax.swing.JButton getButtonPrintListe() {
		return buttonPrintListe;
	}

	public void setButtonPrintListe(javax.swing.JButton buttonPrintListe) {
		this.buttonPrintListe = buttonPrintListe;
	}

public ZEOTable getMyEOTableMois() {
		return myEOTableMois;
	}

	public void setMyEOTableMois(ZEOTable myEOTableMois) {
		this.myEOTableMois = myEOTableMois;
	}

private void buttonCloseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonCloseActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_buttonCloseActionPerformed


private void tfTitreActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tfTitreActionPerformed
    // TODO add your handling code here:
}//GEN-LAST:event_tfTitreActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
            	AgentHistoView dialog = new AgentHistoView(new javax.swing.JFrame(), true, null, null, null,null, null);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton buttonClose;
    private javax.swing.JButton buttonPrintBS;
    private javax.swing.JButton buttonPrintListe;
    protected javax.swing.JComboBox listeExercices;
    private javax.swing.JTextField tfTitre;
    private javax.swing.JPanel viewTableBulletin;
    private javax.swing.JPanel viewTableCout;
    private javax.swing.JPanel viewTableLbud;
    private javax.swing.JPanel viewTableMois;
    // End of variables declaration//GEN-END:variables

    	/*
	 * (non-Javadoc)
	 * 
	 * @see fr.univlr.karukera.client.ZKarukeraPanel#initGUI()
	 */
	private void initGui() {
		
		buttonClose.setIcon(KakiIcones.ICON_CLOSE);		

		buttonPrintBS.setIcon(KakiIcones.ICON_PRINTER_16);		
		buttonPrintListe.setIcon(KakiIcones.ICON_PRINTER_16);		

		Vector<ZEOTableModelColumn> myCols = new Vector<ZEOTableModelColumn>();
		
		ZEOTableModelColumn col = new ZEOTableModelColumn(eod, "CODE" , "Code", 65);
		col.setAlignment(SwingConstants.CENTER);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, "LIBELLE", "Elément", 190);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, "TYPE", "Type", 45);
		col.setAlignment(SwingConstants.CENTER);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, "BUDGET", "BUDGET", 75);
		col.setAlignment(SwingConstants.CENTER);
		col.setTableCellRenderer(myRenderer);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, "PCO_NUM", "COMPTE 6", 60);
		col.setAlignment(SwingConstants.LEFT);
		col.setTableCellRenderer(myRenderer);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, "REMUN", "REMUN", 75);
		col.setAlignment(SwingConstants.RIGHT);
		col.setTableCellRenderer(myRenderer);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, "OUVRIER", "OUVRIER", 75);
		col.setAlignment(SwingConstants.RIGHT);
		col.setTableCellRenderer(myRenderer);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, "INFOS", "INFOS", 75);
		col.setAlignment(SwingConstants.RIGHT);
		col.setTableCellRenderer(myRenderer);
		myCols.add(col);
                col = new ZEOTableModelColumn(eod, "CAT", "Cat", 50);
		col.setAlignment(SwingConstants.CENTER);
		col.setTableCellRenderer(myRenderer);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, "COMPTE6", "6", 40);
		col.setAlignment(SwingConstants.LEFT);
		col.setTableCellRenderer(myRenderer);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, "COMPTE4", "4", 40);
		col.setAlignment(SwingConstants.LEFT);
		col.setTableCellRenderer(myRenderer);
		myCols.add(col);
		
		myTableModel = new ZEOTableModel(eod, myCols);
		myTableSorter = new TableSorter(myTableModel);

		myEOTable = new ZEOTable(myTableSorter);
		myTableSorter.setTableHeader(myEOTable.getTableHeader());		
		
		myEOTable.setBackground(KakiConstantes.COLOR_FOND_NOMENCLATURES);
		myEOTable.setSelectionBackground(KakiConstantes.COLOR_SELECTED_ROW);
		myEOTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);		
		
		viewTableBulletin.setBorder(BorderFactory.createEmptyBorder());
		viewTableBulletin.removeAll();
		viewTableBulletin.setLayout(new BorderLayout());
		viewTableBulletin.add(new JScrollPane(myEOTable), BorderLayout.CENTER);
	
		// MOIS
		
		myCols = new Vector<ZEOTableModelColumn>();
		
		col = new ZEOTableModelColumn(eodMois, EOPafAgent.TO_MOIS_KEY+"."+EOMois.MOIS_LIBELLE_KEY, "MOIS", 50);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);

		myTableModelMois = new ZEOTableModel(eodMois, myCols);
		myTableSorterMois = new TableSorter(myTableModelMois);

		myEOTableMois = new ZEOTable(myTableSorterMois);
		myTableSorterMois.setTableHeader(myEOTableMois.getTableHeader());		
		
		myEOTableMois.setBackground(KakiConstantes.COLOR_FOND_NOMENCLATURES);
		myEOTableMois.setSelectionBackground(KakiConstantes.COLOR_SELECTED_ROW);
		myEOTableMois.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);		
		
		viewTableMois.setBorder(BorderFactory.createEmptyBorder());
		viewTableMois.removeAll();
		viewTableMois.setLayout(new BorderLayout());
		viewTableMois.add(new JScrollPane(myEOTableMois), BorderLayout.CENTER);

		
		// CUMULS
		
		myCols = new Vector<ZEOTableModelColumn>();
		
		col = new ZEOTableModelColumn(eodCumul, EOPafAgentHisto.PAYE_BRUT_KEY , "Brut", 75);
		col.setAlignment(SwingConstants.CENTER);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodCumul, EOPafAgentHisto.PAYE_PATRON_KEY, "Patronal", 75);
		col.setAlignment(SwingConstants.CENTER);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodCumul, EOPafAgentHisto.PAYE_NET_KEY, "Net", 75);
		col.setAlignment(SwingConstants.CENTER);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodCumul, EOPafAgentHisto.PAYE_COUT_KEY, "Cout Total", 75);
		col.setAlignment(SwingConstants.CENTER);
		myCols.add(col);

		myTableModelCumul = new ZEOTableModel(eodCumul, myCols);
		myTableSorterCumul = new TableSorter(myTableModelCumul);

		myEOTableCumul = new ZEOTable(myTableSorterCumul);
		myTableSorterCumul.setTableHeader(myEOTableCumul.getTableHeader());		

		myEOTableCumul.setBackground(KakiConstantes.COLOR_FOND_NOMENCLATURES);
		myEOTableCumul.setSelectionBackground(KakiConstantes.COLOR_SELECTED_ROW);
		myEOTableCumul.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);		

		viewTableCout.setBorder(BorderFactory.createEmptyBorder());
		viewTableCout.removeAll();
		viewTableCout.setLayout(new BorderLayout());
		viewTableCout.add(new JScrollPane(myEOTableCumul), BorderLayout.CENTER);


		
		// LBUD
		
		myCols = new Vector<ZEOTableModelColumn>();
		
		col = new ZEOTableModelColumn(eodLbud, EOPafAgentLbud.ORGAN_KEY + "."+ EOOrgan.ORG_UB_KEY, "UB", 50);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodLbud, EOPafAgentLbud.ORGAN_KEY + "."+ EOOrgan.ORG_CR_KEY, "CR", 75);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodLbud, EOPafAgentLbud.ORGAN_KEY + "."+ EOOrgan.ORG_SOUSCR_KEY, "SOUS CR", 125);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodLbud, EOPafAgentLbud.LOLF_KEY+"."+EOLolfNomenclatureDepense.LOLF_CODE_KEY, "Action", 75);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodLbud, EOPafAgentLbud.CODE_ANALYTIQUE_KEY +"." + EOCodeAnalytique.CAN_CODE_KEY, "Canal", 110);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodLbud, "referenceConvention", "Conv", 80);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodLbud, EOPafAgentLbud.PAGL_QUOTITE_KEY, "Quot", 50);
		col.setAlignment(SwingConstants.RIGHT);
		myCols.add(col);

		myTableModelLbud = new ZEOTableModel(eodLbud, myCols);
		myTableSorterLbud = new TableSorter(myTableModelLbud);

		myEOTableLbud = new ZEOTable(myTableSorterLbud);
		myTableSorterLbud.setTableHeader(myEOTableLbud.getTableHeader());		

		myEOTableLbud.setBackground(KakiConstantes.COLOR_FOND_NOMENCLATURES);
		myEOTableLbud.setSelectionBackground(KakiConstantes.COLOR_SELECTED_ROW);
		myEOTableLbud.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);		

		viewTableLbud.setBorder(BorderFactory.createEmptyBorder());
		viewTableLbud.removeAll();
		viewTableLbud.setLayout(new BorderLayout());
		viewTableLbud.add(new JScrollPane(myEOTableLbud), BorderLayout.CENTER);

		
		
        }
        
    public void setListeExercices(NSArray exercices) {

        listeExercices.removeAllItems();
        for (int i=0;i<exercices.count();i++)
        	listeExercices.addItem(exercices.objectAtIndex(i));
    }

    public void setSelectedExercice(Object exercice) {
        listeExercices.setSelectedItem(exercice);
    }
    

	
	public javax.swing.JComboBox getListeExercices() {
		return listeExercices;
	}

	public void setListeExercices(javax.swing.JComboBox listeExercices) {
		this.listeExercices = listeExercices;
	}

	public javax.swing.JTextField getTfTitre() {
		return tfTitre;
	}

	public void setTfTitre(javax.swing.JTextField tfTitre) {
		this.tfTitre = tfTitre;
	}

	public ZEOTable getMyEOTableCumul() {
		return myEOTableCumul;
	}

	public ZEOTable getMyEOTableLbud() {
		return myEOTableLbud;
	}

	public void setMyEOTableLbud(ZEOTable myEOTableLbud) {
		this.myEOTableLbud = myEOTableLbud;
	}

	public ZEOTableModel getMyTableModelLbud() {
		return myTableModelLbud;
	}

	public void setMyTableModelLbud(ZEOTableModel myTableModelLbud) {
		this.myTableModelLbud = myTableModelLbud;
	}

	public void setMyEOTableCumul(ZEOTable myEOTableCumul) {
		this.myEOTableCumul = myEOTableCumul;
	}

	public ZEOTable getMyEOTable() {
		return myEOTable;
	}

	public void setMyEOTable(ZEOTable myEOTable) {
		this.myEOTable = myEOTable;
	}
}
